﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.ServiceModel.Configuration;
using System.Text;
using System.Threading.Tasks;

namespace AppFx.BZ.Adapter.Behaviours.AzureAD
{    
    public class AzureADBehaviourElement : BehaviorExtensionElement
    {
        public override Type BehaviorType
        {
            get { return typeof(AzureADSecurityBehavior); }
        }

        protected override object CreateBehavior()
        {
            return new AzureADSecurityBehavior(Username, Password, ResourceId, ClientId);
        }

        [ConfigurationProperty("username", IsRequired = true)]
        public string Username
        {
            get { return (string)this["username"]; }
            set { this["username"] = value; }
        }

        [ConfigurationProperty("password", IsRequired = true)]
        public string Password
        {
            get { return (string)this["password"]; }
            set { this["password"] = value; }
        }

        [ConfigurationProperty("clientId", IsRequired = true)]
        public string ClientId
        {
            get { return (string)this["clientId"]; }
            set { this["clientId"] = value; }
        }

        [ConfigurationProperty("resourceId", IsRequired = true)]
        public string ResourceId
        {
            get { return (string)this["resourceId"]; }
            set { this["resourceId"] = value; }
        }        
    }
}
