﻿using Microsoft.IdentityModel.Clients.ActiveDirectory;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AppFx.BZ.Adapter.Behaviours.AzureAD
{
    public class TokenManager
    {
        public TokenManager()
        {
            //ResourceId = "https://analysis.windows.net/powerbi/api";            
            RedirectUri = "https://login.live.com/oauth20_desktop.srf";
            AuthorityUri = "https://login.windows.net/common/oauth2/authorize";
        }

        public string ResourceId { get; set; }
        public string ClientId { get; set; }
        public string RedirectUri { get; set; }
        public string AuthorityUri { get; set; }
        public string Username { get; set; }
        public string Password { get; set; }

        public string AccessToken()
        {
            AuthenticationContext authContext = new AuthenticationContext(AuthorityUri);
            UserCredential userCredential = new UserCredential(Username, Password);
            var token = authContext.AcquireToken(ResourceId, ClientId, userCredential);
            return token.AccessToken;
        }
    }
}
